<?php
include_once(dirname(__FILE__).'/CAS/client.php');

// Configuration pour la base de données
define('TICKET_BDD_PATH', '/var/lib/phpcas/');
define('TICKET_BDD', TICKET_BDD_PATH.'ticket-cache');
define('TICKET_TABLE', 'ticket');
#FIXME : création des répertoires de bdd en postinst + droits

class EoleCASClient extends CASClient
{
    /*
     * FONCTIONS EOLE
     */

    /*
     * Constructeur de la classe
     */
    public function EoleCASClient($server_version,
        $proxy,
        $server_hostname,
        $server_port,
        $server_uri,
        $start_session = true) {
            if (!$this->isLogoutRequest() && !empty($_GET['ticket'])){
                $session_id = session_id();
                $ticket = $_GET['ticket'];
                phpCAS::LOG("La session numéro : " . $session_id . " est associée au ticket : " . $ticket);
                $this->store_session_id($ticket, $session_id);
            }
            parent::CASClient($server_version, $proxy, $server_hostname, $server_port, $server_uri, $start_session);
        }
    /*
     * Fonctions de gestion des ids de session pour la déconnexion centralisée sauce "Eole"
     */
    private function store_session_id($ticket, $session_id){
        /*
         * Stocke le lien ticket<->session_id dans une bdd pour le logout
         */
        phpCAS::traceBegin();
        phpCAS::LOG(" # Enregistrement d'un ticket et de l'id de session #");
        if (!is_dir(TICKET_BDD_PATH)){
            phpCAS::LOG("!!!! Le répertoire pour la bdd de gestion des tickets n'existe pas !!!!");
            phpCAS::traceEnd();
            return;
        }
        $mustcreatetable = !file_exists(TICKET_BDD);
        if (!$db = sqlite_open(TICKET_BDD)){
            phpCAS::LOG("!!!! Impossible d'ouvrir la base de données pour la gestion du logout !!!!");
            phpCAS::traceEnd();
            return;
        }
        if ($mustcreatetable){
            phpCAS::LOG("  + Initialisation de la table dans la base de données");
            $sql = 'CREATE TABLE '.TICKET_TABLE.' (';
            $sql .= 'ticket VARCHAR(70) DEFAULT NULL,';
            $sql .= 'session_id VARCHAR(70) DEFAULT NULL,';
            $sql .= 'dv TIMESTAMP DEFAULT NULL';
            $sql .= ')';
            phpCAS::LOG($sql);
            sqlite_query($db, $sql);
        }
        $now = time();
        $dv=strftime('%Y-%m-%d %H:%M:%S', $now);
        $sql = "INSERT INTO " . TICKET_TABLE ." (ticket, session_id, dv)";
        $sql .= " VALUES ('" . sqlite_escape_string($ticket) . "', '" . sqlite_escape_string($session_id) . "', '" . sqlite_escape_string($dv) . "')";
        phpCAS::LOG("  + Insertion du ticket dans la table");
        phpCAS::LOG($sql);
        if (sqlite_query($db, $sql)){
            phpCAS::LOG("Le ticket '" . $ticket . "' a été enregistré avec comme id de session '" . $session_id . "' à '" . $dv . "'.");
            phpCAS::traceEnd();
        }else{
            phpCAS::LOG("Erreur à l'enregistrement du ticket dans la base de données.");
            phpCAS::traceEnd();
        };
    }
    private function retrieve_session($ticket){
        /*
         * Renvoie l'id de session associé au ticket
         */
        phpCAS::LOG("# Récupération de la session associée au ticket : '" . $ticket ."'.");
        if (!$db = sqlite_open(TICKET_BDD)){
            phpCAS::LOG("!!!! Impossible d'ouvrir la base de données pour la gestion du logout !!!!");
            return;
        }
        $sql = "SELECT session_id from " . TICKET_TABLE . " WHERE ticket='" . sqlite_escape_string($ticket) ."';";
        phpCAS::LOG($sql);
        $result = sqlite_query($db, $sql);
        if ($result){
            $nb = sqlite_num_rows($result);
            if ($nb == 1){
                phpCAS::LOG(" + On a retrouvé l'id de session dans la base de donnée");
                return sqlite_fetch_single($result);
            }else{
                phpCAS::LOG(" - Impossible de retrouver l'id de session");
                exit();
            }
        }else{
            phpCAS::LOG(" - Impossible de rechercher l'id de session : erreur inconnue");
        }
    }
    private function remove_stored_session_id($ticket, $session_id){
        /*
         * Supprime l'enregistrement d'une session
         */
        if (!$db = sqlite_open(TICKET_BDD)){
            phpCAS::LOG("!!!! Impossible d'ouvrir la base de données pour la gestion du logout !!!!");
            return;
        }
        $sql = "DELETE FROM " . TICKET_TABLE . " WHERE ticket=" . sqlite_escape_string($ticket) . " AND session_id=" . sqlite_escape_string($session_id). ";";
        if (sqlite_query($db, $sql)){
            phpCAS::LOG(" + L'id de session a été supprimé de la base de données.");
        }
    }
    private function del_session($ticket){
        /*
         * Fonction de suppression de la session associée au ticket $ticket
         */
        $session_id = $this->retrieve_session($ticket);
        phpCAS::log("  + L'id de la session associée : " . $session_id);
        $fname = "/var/lib/php5/sess_" . $session_id;
        if (file_exists($fname)){
            phpCAS::log("  + Suppression du fichier de session " . $fname);
            if (unlink($fname)){
                phpCAS::log("  => La session a bien été supprimée");
                printf("Disconnected!");
            }else{
                phpCAS::log("  - !! Erreur à la suppression de la session !! ");
            }
        }else{
           phpCAS::log("  - La session a déjà été supprimée !!");
        }
        $this->remove_stored_session_id($ticket, $session_id);
    }
    function EoleLogoutRequests(){
        /*
         * Fonction gérant les requêtes de logout centralisées provenant du serveur sso
         */
        phpCAS::traceBegin();
        if (!$this->isLogoutRequest()) {
            phpCAS::log("Not a logout request");
            phpCAS::traceEnd();
            return;
        }
        phpCAS::log("Logout requested");
        phpCAS::log("SAML REQUEST: ".$_POST['logoutRequest']);
        if ($check_client) {
            if (!$allowed_clients) {
                $allowed_clients = array( $this->getServerHostname() );
            }
            $client_ip = $_SERVER['REMOTE_ADDR'];
            $client = gethostbyaddr($client_ip);
            phpCAS::log("Client: ".$client);
            $allowed = false;
            foreach ($allowed_clients as $allowed_client) {
                if ($client == $allowed_client) {
                    phpCAS::log("Allowed client '".$allowed_client."' matches, logout request is allowed");
                    $allowed = true;
                    break;
                } else {
                    phpCAS::log("Allowed client '".$allowed_client."' does not match");
                }
            }
            if (!$allowed) {
                phpCAS::error("Unauthorized logout request from client '".$client."'");
                printf("Unauthorized!");
                phpCAS::traceExit();
                exit();
            }
        } else {
            phpCAS::log("No access control set");
        }
		// Récupération du ticket dans la requête SAML
		preg_match("|<samlp:SessionIndex>(.*)</samlp:SessionIndex>|", $_POST['logoutRequest'], $tick, PREG_OFFSET_CAPTURE, 3);
		$wrappedSamlSessionIndex = preg_replace('|<samlp:SessionIndex>|','',$tick[0][0]);
        $ticket2logout = preg_replace('|</samlp:SessionIndex>|','',$wrappedSamlSessionIndex);
        if (! preg_match('/^[SP]T-/',$ticket2logout) ) {
            phpCAS::log("Doesn't look like a ticket." );
            exit();
        }else{
            phpCAS::log("Ticket to logout: ".$ticket2logout);
        }
        $this->del_session($ticket2logout);
        phpCAS::traceExit();
        exit();
    }

    /*
     * Fonctions de gestion des détails utilisateurs
     * set et getDetails
     */
    private function setDetails($details){
        $this->details = $details;
    }
    public function getDetails(){
        if ( empty($this->details)){
            phpCAS::error('this method (getDetails) should be used only after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
        }
        return $this->details;
    }
    /*
     * Fontions de gestion du xml renvoyé par le sso eole
     * set et get CasXML
     * */
    private function setCasXML($dom){
        $this->casxml = $dom;
    }
    public function getCasXML(){
        if ( empty($this->casxml)){
            phpCAS::error('this method (getCasXML) should be used only after '.__CLASS__.'::forceAuthentication() or '.__CLASS__.'::isAuthenticated()');
        }
        return $this->casxml;
    }
    private function parseTicket($dom) {
        /*
         * fonction de parsing du ticket Cas renvoyant les infos user et details
         * format du retour à traiter:
         <cas:authenticationSuccess>
         <cas:section>
         <cle1>valeur</cle1>
         <cle2>valeur</cle2>
         </cas:section>
         </cas:authenticationSuccess>

         renvoie {section:{cle1:valeur, cle2:valeur}}
         ou
         <cas:authenticationSuccess>
         <cas:section>valeur</cas:section>
         </cas:authenticationSuccess>

         renvoie {section:valeur}
         */
        $details = array();
        $user = "undefined";
        // Pour chaque section
        foreach($dom->child_nodes() as $section){
            // si la section a des enfants
            if ($section->has_child_nodes()){
                $subdetails = array();
                // on traite les sous-sections
                foreach($section->child_nodes() as $node){
                    if ($node->node_name() != ""){
                        if (! isset($subdetails[$node->node_name()])){
                            $subdetails[$node->node_name()] = Array($node->get_content());
                        }else{
                            $subdetails[$node->node_name()][] = $node->get_content();
                        }
                    }
                }
                if (sizeof($subdetails) == 0){
                    $subdetails = $section->get_content();
                }
                if ($section->node_name() != ""){
                    $details[$section->node_name()] = $subdetails;
                }
            }
            // si elle est elle-meme la cle
            else{
                if ($section->node_name() != ""){
                    $details[$section->node_name()] = $section->get_content();
                }
            }
        }
        // on récupère le nom de l'utilisateur (inclue dans le comportement traditionnel de la lib CAS)
        if (isset($details['user'])){
            if (is_array($details['user'])){
                if (isset($details['user']['user'])){
                    if (is_array($details['user']['user'])){
                        $user = $details['user']['user'][0];
                    }else{
                        $user = $details['user']['user'];
                    }
                }else{
                    $user = $details['user'][0];
                }
            }else{
                $user = $details['user'];
            }
        }elseif (isset($details['utilisateur'])){ // cas où aucun filtre eole-sso n'a été appliqué (filtre par défaut)
            if (isset($details['utilisateur']['user'])){
                if (is_array($details['utilisateur']['user'])){
                    $user = $details['utilisateur']['user'][0];
                }else{
                    $user = $details['utilisateur']['user'];
                }
            }
        }
        return array($user, $details);
    }

    /*
     * FONCTIONS ÉCRASÉES
     */
    public function isAuthenticated()
        {
            /*
             * isAuthenticated : comme son nom l'indique
             */
            phpCAS::traceBegin();
            $res = FALSE;
            $validate_url = '';
            if ( $this->wasPreviouslyAuthenticated() ) {
                // the user has already (previously during the session) been
                // authenticated, nothing to be done.
                phpCAS::trace('user was already authenticated, no need to look for tickets');
                $res = TRUE;
            }
            elseif ( $this->hasST() ) {
                // if a Service Ticket was given, validate it
                phpCAS::trace('ST `'.$this->getST().'\' is present');
                $this->validateST($validate_url,$text_response,$tree_response); // if it fails, it halts
                phpCAS::trace('ST `'.$this->getST().'\' was validated');
                if ( $this->isProxy() ) {
                    $this->validatePGT($validate_url,$text_response,$tree_response); // idem
                    phpCAS::trace('PGT `'.$this->getPGT().'\' was validated');
                    $_SESSION['phpCAS']['pgt'] = $this->getPGT();
                }
                $_SESSION['phpCAS']['user'] = $this->getUser();
                // Specification Eole////////////////////////////////
                $_SESSION['phpCAS']['details'] = $this->getDetails();
                $_SESSION['phpCAS']['casxml'] = $this->getCasXML();
                /////////////////////////////////////////////////////
                $res = TRUE;
            }
            elseif ( $this->hasPT() ) {
                // if a Proxy Ticket was given, validate it
                phpCAS::trace('PT `'.$this->getPT().'\' is present');
                $this->validatePT($validate_url,$text_response,$tree_response); // note: if it fails, it halts
                phpCAS::trace('PT `'.$this->getPT().'\' was validated');
                if ( $this->isProxy() ) {
                    $this->validatePGT($validate_url,$text_response,$tree_response); // idem
                    phpCAS::trace('PGT `'.$this->getPGT().'\' was validated');
                    $_SESSION['phpCAS']['pgt'] = $this->getPGT();
                }
                $_SESSION['phpCAS']['user'] = $this->getUser();
                // Specification Eole////////////////////////////////
                $_SESSION['phpCAS']['details'] = $this->getDetails();
                $_SESSION['phpCAS']['casxml'] = $this->getCasXML();
                /////////////////////////////////////////////////////
                $res = TRUE;
            }
            else {
                // no ticket given, not authenticated
                phpCAS::trace('no ticket found');
            }

            phpCAS::traceEnd($res);
            return $res;
        }
    public function wasPreviouslyAuthenticated()
    {
        /*
         * Test si on est déjà authentifié, dans ce cas on récupère les valeurs dans la session
         */
        phpCAS::traceBegin();

        if ( $this->isCallbackMode() ) {
            $this->callback();
        }

        $auth = FALSE;

        if ( $this->isProxy() ) {
            // CAS proxy: username and PGT must be present
            if ( $this->isSessionAuthenticated() && !empty($_SESSION['phpCAS']['pgt']) ) {
                // authentication already done
                $this->setUser($_SESSION['phpCAS']['user']);
                // Specification Eole////////////////////////////////
                if (isset($_SESSION['phpCAS']['details'])){
                    $this->setDetails($_SESSION['phpCAS']['details']);
                }
                else{
                    $this->setDetails('__Void__');
                }
                if (isset($_SESSION['phpCAS']['casxml'])){
                    $this->setCasXML($_SESSION['phpCAS']['casxml']);
                }
                else{
                    $this->setCasXML("__VoidXML___");
                }
                //////////////////////////////////////////////////////
                $this->setPGT($_SESSION['phpCAS']['pgt']);
                phpCAS::trace('user = `'.$_SESSION['phpCAS']['user'].'\', PGT = `'.$_SESSION['phpCAS']['pgt'].'\'');
                $auth = TRUE;
            } elseif ( $this->isSessionAuthenticated() && empty($_SESSION['phpCAS']['pgt']) ) {
                // these two variables should be empty or not empty at the same time
                phpCAS::trace('username found (`'.$_SESSION['phpCAS']['user'].'\') but PGT is empty');
                // unset all tickets to enforce authentication
                unset($_SESSION['phpCAS']);
                $this->setST('');
                $this->setPT('');
            } elseif ( !$this->isSessionAuthenticated() && !empty($_SESSION['phpCAS']['pgt']) ) {
                // these two variables should be empty or not empty at the same time
                phpCAS::trace('PGT found (`'.$_SESSION['phpCAS']['pgt'].'\') but username is empty');
                // unset all tickets to enforce authentication
                unset($_SESSION['phpCAS']);
                $this->setST('');
                $this->setPT('');
            } else {
                phpCAS::trace('neither user not PGT found');
            }
        } else {
            // `simple' CAS client (not a proxy): username must be present
            if ( $this->isSessionAuthenticated() ) {
                // authentication already done
                $this->setUser($_SESSION['phpCAS']['user']);

                // Specification pour les détails
                if (isset($_SESSION['phpCAS']['details'])){
                    $this->setDetails($_SESSION['phpCAS']['details']);
                }
                else{
                    $this->setDetails("__Void___");
                }
                if (isset($_SESSION['phpCAS']['casxml'])){
                    $this->setCasXML($_SESSION['phpCAS']['casxml']);
                }
                else{
                    $this->setCasXML("__VoidXML___");
                }

                phpCAS::trace('user = `'.$_SESSION['phpCAS']['user'].'\'');
                $auth = TRUE;
            } else {
                phpCAS::trace('no user found');
            }
        }
        phpCAS::traceEnd($auth);
        return $auth;
    }
    public function validatePT(&$validate_url,&$text_response,&$tree_response)
    {
        /*
         * Fonction de validation du ticket PT, récupère le xml et inscrit les informations associées
         */
        phpCAS::traceBegin();
        // build the URL to validate the ticket
        $validate_url = $this->getServerProxyValidateURL().'&ticket='.$this->getPT();
        if ( $this->isProxy() ) {
            // pass the callback url for CAS proxies
            $validate_url .= '&pgtUrl='.$this->getCallbackURL();
        }
        // open and read the URL
        if ( !$this->readURL($validate_url,''/*cookies*/,$headers,$text_response,$err_msg) ) {
            phpCAS::trace('could not open URL \''.$validate_url.'\' to validate ('.$err_msg.')');
            $this->authError('PT not validated',
                $validate_url,
                TRUE/*$no_response*/);
        }
        // read the response of the CAS server into a DOM object
        if ( !($dom = domxml_open_mem($text_response))) {
            // read failed
            $this->authError('PT not validated',
                $validate_url,
                FALSE/*$no_response*/,
                TRUE/*$bad_response*/,
                $text_response);
        }
        // read the root node of the XML tree
        if ( !($tree_response = $dom->document_element()) ) {
            // read failed
            $this->authError('PT not validated',
                $validate_url,
                FALSE/*$no_response*/,
                TRUE/*$bad_response*/,
                $text_response);
        }
        // insure that tag name is 'serviceResponse'
        if ( $tree_response->node_name() != 'serviceResponse' ) {
            // bad root node
            $this->authError('PT not validated',
                $validate_url,
                FALSE/*$no_response*/,
                TRUE/*$bad_response*/,
                $text_response);
        }
        if ( sizeof($arr = $tree_response->get_elements_by_tagname("authenticationSuccess")) != 0) {
            // authentication succeded, extract the user name
            if ( sizeof($arr = $tree_response->get_elements_by_tagname("user")) == 0) {
                // no user specified => error
                $this->authError('PT not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    TRUE/*$bad_response*/,
                    $text_response);
            }
            $user_datas_tag = $tree_response->get_elements_by_tagname("authenticationSuccess");
            $this->setCasXML($text_response);
            $datas = $this->parseTicket($user_datas_tag[0]);
            $this->setUser($datas[0]);
            // Specifications Eole///////
            $this->setDetails($datas[1]);
            /////////////////////////////
        } else if ( sizeof($arr = $tree_response->get_elements_by_tagname("authenticationFailure")) != 0) {
            // authentication succeded, extract the error code and message
            $this->authError('PT not validated',
                $validate_url,
                FALSE/*$no_response*/,
                FALSE/*$bad_response*/,
                $text_response,
                $arr[0]->get_attribute('code')/*$err_code*/,
                trim($arr[0]->get_content())/*$err_msg*/);
        } else {
            $this->authError('PT not validated',
                $validate_url,
                FALSE/*$no_response*/,
                TRUE/*$bad_response*/,
                $text_response);
        }
        // at this step, PT has been validated and $this->_user has been set,
        phpCAS::traceEnd(TRUE);
        return TRUE;
    }

    public function validateST($validate_url,&$text_response,&$tree_response)
    {
        /*
         * Fonction de validation d'un ST pour récupération d'un pgt
         */
        phpCAS::traceBegin();
        // build the URL to validate the ticket
        $validate_url = $this->getServerServiceValidateURL().'&ticket='.$this->getST();
        if ( $this->isProxy() ) {
            // pass the callback url for CAS proxies
            $validate_url .= '&pgtUrl='.$this->getCallbackURL();
        }
        // open and read the URL
        if ( !$this->readURL($validate_url,''/*cookies*/,$headers,$text_response,$err_msg) ) {
            phpCAS::trace('could not open URL \''.$validate_url.'\' to validate ('.$err_msg.')');
            $this->authError('ST not validated',
                $validate_url,
                TRUE/*$no_response*/);
        }
        // analyze the result depending on the version
        switch ($this->getServerVersion()) {
        case CAS_VERSION_1_0:
            if (preg_match('/^no\n/',$text_response)) {
                phpCAS::trace('ST has not been validated');
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    FALSE/*$bad_response*/,
                    $text_response);
            }
            if (!preg_match('/^yes\n/',$text_response)) {
                phpCAS::trace('ill-formed response');
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    TRUE/*$bad_response*/,
                    $text_response);
            }
            // ST has been validated, extract the user name
            $arr = preg_split('/\n/',$text_response);
            $this->setUser(trim($arr[1]));
            // Specification Eole (pas d'infos user en Cas 1)
            $this->setDetails("NO INFOS");
            $this->setCasXML("NO XML");
            /////////////////////////////////////////////////
            break;
        case CAS_VERSION_2_0:
            // read the response of the CAS server into a DOM object
            if ( !($dom = domxml_open_mem($text_response))) {
                phpCAS::trace('domxml_open_mem() failed');
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    TRUE/*$bad_response*/,
                    $text_response);
            }
            // read the root node of the XML tree
            if ( !($tree_response = $dom->document_element()) ) {
                phpCAS::trace('document_element() failed');
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    TRUE/*$bad_response*/,
                    $text_response);
            }
            // insure that tag name is 'serviceResponse'
            if ( $tree_response->node_name() != 'serviceResponse' ) {
                phpCAS::trace('bad XML root node (should be `serviceResponse\' instead of `'.$tree_response->node_name().'\'');
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    TRUE/*$bad_response*/,
                    $text_response);
            }
            if ( sizeof($success_elements = $tree_response->get_elements_by_tagname("authenticationSuccess")) != 0) {
                // authentication succeded, extract the user name
                if ( sizeof($user_elements = $success_elements[0]->get_elements_by_tagname("user")) == 0) {
                    phpCAS::trace('<authenticationSuccess> found, but no <user>');
                    $this->authError('ST not validated',
                        $validate_url,
                        FALSE/*$no_response*/,
                        TRUE/*$bad_response*/,
                        $text_response);
                }
                $user_datas_tag = $tree_response->get_elements_by_tagname("authenticationSuccess");
                $datas = $this->parseTicket($user_datas_tag[0]);
                $this->setCasXML($text_response);
                $this->setUser($datas[0]);
                // Specification Eole////////
                $this->setDetails($datas[1]);
                /////////////////////////////
            } else if ( sizeof($failure_elements = $tree_response->get_elements_by_tagname("authenticationFailure")) != 0) {
                phpCAS::trace('<authenticationFailure> found');
                // authentication failed, extract the error code and message
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    FALSE/*$bad_response*/,
                    $text_response,
                    $failure_elements[0]->get_attribute('code')/*$err_code*/,
                    trim($failure_elements[0]->get_content())/*$err_msg*/);
            } else {
                phpCAS::trace('neither <authenticationSuccess> nor <authenticationFailure> found');
                $this->authError('ST not validated',
                    $validate_url,
                    FALSE/*$no_response*/,
                    TRUE/*$bad_response*/,
                    $text_response);
            }
            break;
        }
        // at this step, ST has been validated and $this->_user has been set,
        phpCAS::traceEnd(TRUE);
        return TRUE;
    }
}
